程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C++ >> C++入門知識 >> hdu 1180 詭異的樓梯 樓梯可以變方向的搜索題

hdu 1180 詭異的樓梯 樓梯可以變方向的搜索題

編輯:C++入門知識

詭異的樓梯
Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 6570    Accepted Submission(s): 1547

 

Problem Description
Hogwarts正式開學以後,Harry發現在Hogwarts裡,某些樓梯並不是靜止不動的,相反,他們每隔一分鐘就變動一次方向.
比如下面的例子裡,一開始樓梯在豎直方向,一分鐘以後它移動到了水平方向,再過一分鐘它又回到了豎直方向.Harry發現對他來說很難找到能使得他最快到達目的地的路線,這時Ron(Harry最好的朋友)告訴Harry正好有一個魔法道具可以幫助他尋找這樣的路線,而那個魔法道具上的咒語,正是由你纂寫的.

 


Input
測試數據有多組,每組的表述如下:
第一行有兩個數,M和N,接下來是一個M行N列的地圖,'*'表示障礙物,'.'表示走廊,'|'或者'-'表示一個樓梯,並且標明了它在一開始時所處的位置:'|'表示的樓梯在最開始是豎直方向,'-'表示的樓梯在一開始是水平方向.地圖中還有一個'S'是起點,'T'是目標,0<=M,N<=20,地圖中不會出現兩個相連的梯子.Harry每秒只能停留在'.'或'S'和'T'所標記的格子內.

 


Output
只有一行,包含一個數T,表示到達目標的最短時間.
注意:Harry只能每次走到相鄰的格子而不能斜走,每移動一次恰好為一分鐘,並且Harry登上樓梯並經過樓梯到達對面的整個過程只需要一分鐘,Harry從來不在樓梯上停留.並且每次樓梯都恰好在Harry移動完畢以後才改變方向.

 


Sample Input
5 5
**..T
**.*.
..|..
.*.*.
S....


Sample Output
7

HintHint
地圖如下:
 


Source
Gardon-DYGG Contest 1
 


Recommend
JGShining
 
飛機票:
http://acm.hdu.edu.cn/showproblem.php?pid=1180
 
思路 :模擬 BFS
 
注意樓梯用過了1遍之後還可以再用 因為用來橫著走之後還可以豎著走 所以不標記樓梯是否走過
一開始沒考慮這裡 wa了一次       修改了之後直接過了 發現做題的時候腦子要清醒才行 這樣才能 快狠准
代碼有點長   by  hnust_xiehonghao
[cpp]  #include<stdio.h>  
#include<queue>  
#include<string.h>  
using namespace std; 
char map[30][30]; 
int vis[30][30]; 
int sx,sy,ex,ey,n,m; 
struct haha 

    int x; 
    int y; 
    int step; 
    friend bool operator<(haha a,haha b) 
    { 
        return a.step>b.step; 
    } 
}q,temp; 
int dir[4][2]={1,0,-1,0,0,1,0,-1}; 
bool can(int xx,int yy) 

    if(xx>=0&&xx<n&&yy>=0&&yy<m&&map[xx][yy]!='*'&&!vis[xx][yy]) return true; 
    return false; 

int BFS() 

    int i; 
    priority_queue<struct haha>que; 
    q.x=sx; 
    q.y=sy; 
    q.step=0; 
    que.push(q); 
    memset(vis,0,sizeof(vis)); 
    vis[sx][sy]=1; 
    while(!que.empty()) 
    { 
        temp=que.top(); 
        que.pop(); 
        if(temp.x==ex&&temp.y==ey) return temp.step; 
        for(i=0;i<4;i++) 
        { 
 
            int xx;int yy; 
            xx=temp.x+dir[i][0]; 
            yy=temp.y+dir[i][1]; 
            if(can(xx,yy)) 
            { 
                if(map[xx][yy]=='|')//如果初始狀態為|  
                { 
                    if(temp.step%2==0)//如果已經走了step步 為偶數步 則狀態不變  
                    { 
                        if(can(xx+dir[i][0],yy+dir[i][1]))//方向不變穿越樓梯看是否能走  
                        { 
                            q.x=xx+dir[i][0]; 
                            q.y=yy+dir[i][1]; 
                            vis[q.x][q.y]=1; 
                            if((i==1||i==0))//0,1對應的是豎著走 因此直接走 所以加1  
                            { 
 
                                q.step=temp.step+1; 
                                que.push(q); 
                            } 
                            else//2 3 對應橫著走  由於是狀態不變 所以要等到它變為-後再走 所以加2  
                            { 
                                q.step=temp.step+2; 
                                que.push(q); 
                            } 
                        } 
 
                    } 
                    else 
                    { 
                        if(can(xx+dir[i][0],yy+dir[i][1])) 
                        { 
                            q.x=xx+dir[i][0]; 
                            q.y=yy+dir[i][1]; 
                            vis[q.x][q.y]=1; 
                            if((i==1||i==0)) 
                            { 
 
                                q.step=temp.step+2; 
                                que.push(q); 
                            } 
                            else 
                            { 
                                q.step=temp.step+1; 
                                que.push(q); 
                            } 
                        } 
                    } 
                } 
                else  if(map[xx][yy]=='-') 
                { 
                    if(temp.step%2==0) 
                    { 
                        if(can(xx+dir[i][0],yy+dir[i][1])) 
                        { 
                            q.x=xx+dir[i][0]; 
                            q.y=yy+dir[i][1]; 
                            vis[q.x][q.y]=1; 
                            if((i==1||i==0)) 
                            { 
 
                                q.step=temp.step+2; 
                                que.push(q); 
                            } 
                            else 
                            { 
                                q.step=temp.step+1; 
                                que.push(q); 
                            } 
                        } 
 
                    } 
                    else 
                    { 
                        if(can(xx+dir[i][0],yy+dir[i][1])) 
                        { 
                            q.x=xx+dir[i][0]; 
                            q.y=yy+dir[i][1]; 
                            vis[q.x][q.y]=1; 
                            if((i==1||i==0)) 
                            { 
                                    
                                q.step=temp.step+1; 
                                que.push(q); 
                            } 
                            else 
                            { 
                                q.step=temp.step+2; 
                                que.push(q); 
                            } 
                        } 
                    } 
                } 
                else 
                { 
                vis[xx][yy]=1; 
                /*注意樓梯用過了1遍之後還可以再用 因為用來橫著走之後還可以豎著走 所以不標記樓梯是否走過*/ 
                q.x=xx; 
                q.y=yy; 
                q.step=temp.step+1; 
                que.push(q); 
                } 
            } 
        } 
    } 

int main() 

    int i,j; 
    while(scanf("%d %d",&n,&m)!=EOF) 
    { 
        for(i=0;i<n;i++) 
        { 
            scanf("%s",map[i]); 
            for(j=0;j<m;j++) 
            { 
                if(map[i][j]=='S') {sx=i;sy=j;} 
                else if(map[i][j]=='T') {ex=i;ey=j;} 
            } 
        } 
        int ans=0;  ans=BFS(); 
        printf("%d\n",ans); 
    } 
    return 0; 

#include<stdio.h>
#include<queue>
#include<string.h>
using namespace std;
char map[30][30];
int vis[30][30];
int sx,sy,ex,ey,n,m;
struct haha
{
 int x;
 int y;
 int step;
 friend bool operator<(haha a,haha b)
 {
     return a.step>b.step;
 }
}q,temp;
int dir[4][2]={1,0,-1,0,0,1,0,-1};
bool can(int xx,int yy)
{
 if(xx>=0&&xx<n&&yy>=0&&yy<m&&map[xx][yy]!='*'&&!vis[xx][yy]) return true;
 return false;
}
int BFS()
{
 int i;
 priority_queue<struct haha>que;
 q.x=sx;
 q.y=sy;
 q.step=0;
 que.push(q);
 memset(vis,0,sizeof(vis));
 vis[sx][sy]=1;
 while(!que.empty())
 {
  temp=que.top();
  que.pop();
  if(temp.x==ex&&temp.y==ey) return temp.step;
  for(i=0;i<4;i++)
  {

   int xx;int yy;
   xx=temp.x+dir[i][0];
   yy=temp.y+dir[i][1];
   if(can(xx,yy))
   {
    if(map[xx][yy]=='|')//如果初始狀態為|
    {
     if(temp.step%2==0)//如果已經走了step步 為偶數步 則狀態不變
     {
      if(can(xx+dir[i][0],yy+dir[i][1]))//方向不變穿越樓梯看是否能走
      {
       q.x=xx+dir[i][0];
       q.y=yy+dir[i][1];
       vis[q.x][q.y]=1;
       if((i==1||i==0))//0,1對應的是豎著走 因此直接走 所以加1
       {

        q.step=temp.step+1;
        que.push(q);
       }
       else//2 3 對應橫著走  由於是狀態不變 所以要等到它變為-後再走 所以加2
       {
        q.step=temp.step+2;
        que.push(q);
       }
      }

     }
     else
     {
      if(can(xx+dir[i][0],yy+dir[i][1]))
      {
       q.x=xx+dir[i][0];
       q.y=yy+dir[i][1];
       vis[q.x][q.y]=1;
       if((i==1||i==0))
       {

        q.step=temp.step+2;
        que.push(q);
       }
       else
       {
        q.step=temp.step+1;
        que.push(q);
       }
      }
     }
    }
    else  if(map[xx][yy]=='-')
    {
     if(temp.step%2==0)
     {
      if(can(xx+dir[i][0],yy+dir[i][1]))
      {
       q.x=xx+dir[i][0];
       q.y=yy+dir[i][1];
       vis[q.x][q.y]=1;
       if((i==1||i==0))
       {

        q.step=temp.step+2;
        que.push(q);
       }
       else
       {
        q.step=temp.step+1;
        que.push(q);
       }
      }

     }
     else
     {
      if(can(xx+dir[i][0],yy+dir[i][1]))
      {
       q.x=xx+dir[i][0];
       q.y=yy+dir[i][1];
       vis[q.x][q.y]=1;
       if((i==1||i==0))
       {
                                  
        q.step=temp.step+1;
        que.push(q);
       }
       else
       {
        q.step=temp.step+2;
        que.push(q);
       }
      }
     }
    }
    else
                {
    vis[xx][yy]=1;
    /*注意樓梯用過了1遍之後還可以再用 因為用來橫著走之後還可以豎著走 所以不標記樓梯是否走過*/
    q.x=xx;
    q.y=yy;
    q.step=temp.step+1;
    que.push(q);
    }
   }
  }
 }
}
int main()
{
 int i,j;
 while(scanf("%d %d",&n,&m)!=EOF)
 {
  for(i=0;i<n;i++)
  {
   scanf("%s",map[i]);
   for(j=0;j<m;j++)
   {
    if(map[i][j]=='S') {sx=i;sy=j;}
    else if(map[i][j]=='T') {ex=i;ey=j;}
   }
  }
  int ans=0;  ans=BFS();
  printf("%d\n",ans);
 }
 return 0;
}


 
 
 

  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved